; Begin
	R0L EQU 0xC
	R0H EQU 0xD
	R1L EQU 0xE
	R1H EQU 0xF
	R2L EQU 0x10
	R2H EQU 0x11
	R3L EQU 0x12
	R3H EQU 0x13
	R4L EQU 0x14
	R4H EQU 0x15
	R5L EQU 0x16
	R5H EQU 0x17
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0004
	ORG 0x0004
	RETFIE
L0004:
; 1:  'TJACO'S DESIGN GRAVEYARD: WWW.GEOCITIES.COM/TJACODESIGN
; 2:  '22 JULY 2002
; 3:  'CERBERES : MINI ROBOT WITH IR EYES
; 4:  'USES PIC16F84 CONTROLLER
; 5:  '
; 6:  'Adapted source to BASIC Compiller PIC Simulator IDE by Tiffany: odometer@narod.ru
; 7:  'FOR PIC16F84A
; 8: 
; 9: TRISB = %11110000 'RB7,6,5,4 IS INPUT or RB3,2,1,0 IS OUTPUT
	BSF STATUS,RP0
	MOVLW 0xF0
	MOVWF 0x06
	BCF STATUS,RP0
; 10: PORTB = %00000000
	CLRF 0x06
; 11: 
; 12: start: 
L0001:
; 13: PORTB = %00001001 'MAKE RB3&1 HIGH: MOVE FORWARD
	MOVLW 0x09
	MOVWF 0x06
; 14: If PORTB.5 = 0 Then Gosub backl 'CHECK RB5 (INPUT); IF IT IS LOW
	BTFSC 0x06,5
	GOTO L0005
	CALL L0002
L0005:	MOVLW 0x1F
	ANDWF STATUS,F
; 15:  'THEN EXECUTE BACKLEFT ROUTINE
; 16: If PORTB.6 = 0 Then Gosub backr 'CHECK RB6 (INPUT); IF IT IS LOW
	BTFSC 0x06,6
	GOTO L0006
	CALL L0003
L0006:	MOVLW 0x1F
	ANDWF STATUS,F
; 17:  'THEN EXECUTE BACKLEFT ROUTINE
; 18: Goto start
	GOTO L0001
; 19: End
L0007:	GOTO L0007
; 20: 
; 21: backl: 
L0002:
; 22: PORTB = %00000000 'MAKE RB LOW: STOP
	CLRF 0x06
; 23: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 24: PORTB = %00000110 'MAKE RB2&1 HIGH: MOVE BACKWARD
	MOVLW 0x06
	MOVWF 0x06
; 25: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 26: PORTB = %00000000 'MAKE RB LOW: STOP
	CLRF 0x06
; 27: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 28: PORTB = %00001010 'MAKE RB3&1 HIGH: ROTATE LEFT
	MOVLW 0x0A
	MOVWF 0x06
; 29: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 30: PORTB = %00000000 'MAKE RB LOW: STOP
	CLRF 0x06
; 31: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 32: Return
	RETURN
; 33: 
; 34: backr: 
L0003:
; 35: PORTB = %00000000 'MAKE RB LOW: STOP
	CLRF 0x06
; 36: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 37: PORTB = %00000110 'MAKE RB2&1 HIGH: MOVE BACKWARD
	MOVLW 0x06
	MOVWF 0x06
; 38: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 39: PORTB = %00000000 'MAKE RB LOW: STOP
	CLRF 0x06
; 40: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 41: PORTB = %00000101 'MAKE RB2&0 HIGH: ROTATE RIGHT
	MOVLW 0x05
	MOVWF 0x06
; 42: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 43: PORTB = %00000000 'MAKE RB LOW: STOP
	CLRF 0x06
; 44: WaitMs 100
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
; 45: Return
	RETURN
; End of program
L0008:	GOTO L0008
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; End of listing
	END
